package{
  import flash.display.BitmapData;

//--------------------------------------------------------------------//
// Qn}f[^
  public class WorldMapData{

// \̈O\
    public static const OUT:int=-1;  

// pxWAɕϊW
    public static const TO_RADIAN:Number=Math.PI/180.0;

// f[^
    public var base:BitmapData;

// wiF
    public var bgColor:uint;

//--------------------------------------------------------------------//
    public function WorldMapData(base:BitmapData,bgColor:uint):void{
      this.base=base;
      this.bgColor=bgColor;
    }

//--------------------------------------------------------------------//
// nV̓_Ԃ
// x,y - ʏ̑Έʒu
// theta,phy - ]p
    public function getGlobePoint(x:Number,y:Number,
      	      	      	      	  theta:Number,phy:Number):int{
      var r2:Number=1.0-(x*x+y*y);
      if(r2<0.0) return OUT;

      var sphy:Number=Math.sin(TO_RADIAN*phy);
      var cphy:Number=Math.cos(TO_RADIAN*phy);
      var r:Number=Math.sqrt(r2);
      var ssy:Number=sphy*r+cphy*y;
      var ccy:Number=1.0-ssy*ssy;
      if(ccy<1.0e-12){
      	if(ssy>0.0){	// kɓ_
      	  return base.getPixel(0,0);
      	}
      	else{		// ɓ_
      	  return base.getPixel(base.width-1,base.height-1);
      	}
      }
      else{
      	var yy:Number=Math.asin(ssy)/Math.PI;
      	var ccx:Number=(cphy*r-sphy*y)/Math.sqrt(ccy);
      	var xx:Number=0.0;
      	if(ccx<-1.0+1.0e-12)      xx=0.5;
      	else if(ccx<=1.0-1.0e-12) xx=0.5*Math.acos(ccx)/Math.PI;
      	if(x<0) xx=-xx;
      	var i:int=base.width/2+int(base.width*(xx+theta/360.0));
      	var j:int=base.height/2-int(base.height*yy);
      	return base.getPixel(i%base.width,j);
      }
    }
  }
}
