package{
  import flash.display.BitmapData;
  import flash.events.Event;
  import flash.events.EventDispatcher;  

//--------------------------------------------------------------------//
// Q}bvǂݍ݃NX
  public class WorldMapReader extends EventDispatcher{

// 摜f[^
    private var image:BitmapData;

//--------------------------------------------------------------------//
// f[^ǂݍ
    public function readData(fileName:String,imageName:String,
      	      	      	     model:WorldMapModel):void{
      if(imageName==""){
      	image=null;
      	readTextData(fileName,model);
      }
      else{
      	var img:ImageLoader=new ImageLoader(imageName);
      	img.addEventListener(ImageLoader.LOAD_COMPLETE,imgLoaded);
      	function imgLoaded():void{
      	  image=img.data;
      	  readTextData(fileName,model);
      	}
      }
    }

//--------------------------------------------------------------------//
// f[^ǂݍ
    private function readTextData(fileName:String,
      	      	      	      	  model:WorldMapModel):void{
      var data:TableData=new TableData();
      data.readData(fileName);
      data.addEventListener(TableData.LOAD_COMPLETE,onTextLoaded);

      function onTextLoaded(event:Event):void{

      	var ii:int=0;
      	var jj:int=0;
      	var row:int=360;
      	var col:int=720;
      	var regions:uint=0;
      	var imageFile:Boolean=(image!=null);
      	var regionMap:Object=new Object();

      	while(ii<data.array.length){
      	  if(data.array[ii].length>=3){
      	    var word:String=String(data.array[ii][0]).toLowerCase();
      	    if(word=="init"){
      	      model.map.setLocation(Number(data.array[ii][1]),
      	      	      	      	    Number(data.array[ii][2]));
      	    }
      	    else if(word=="region"){
      	      col=int(data.array[ii][1]);
      	      row=int(data.array[ii][2]);
      	      if(!imageFile){
      	      	image=new BitmapData(col,row,false,0x000000);
      	      }
      	    }
      	    else{
      	      var id:int=int(word);
      	      var color:uint=uint("0x"+data.array[ii][1]);
      	      var name:String=String(data.array[ii][2]);
      	      model.setRegion(regions,new Region(name,color));
      	      regionMap[String(color)]=regions;
      	      regions++;
      	    }
      	  }
      	  else if(data.array[ii].length==2){
      	    var count:int=int(data.array[ii][0]);
      	    var pt:int=int(data.array[ii][1]);
      	    for(var i:int=0;i<count;i++){
      	      image.setPixel(jj%image.width,jj/image.width,pt);
      	      jj++;
      	    }
      	  }
      	  else if(data.array[ii].length==1){
      	    model.setRegionsCount(int(data.array[ii][0]));
      	  }
      	  ii++;
      	}
      	if(imageFile){
      	  image.lock();
      	  for(i=0;i<image.width;i++){
      	    for(var j:int=0;j<image.height;j++){
      	      var pix:String=String(image.getPixel(i,j));
      	      image.setPixel(i,j,regionMap[pix]);
      	    }
      	  }
      	  image.unlock();
      	}
      	regionMap=null;
      	model.setData(new WorldMapData(image,0x000000));
      	dispatchEvent(new Event(TableData.LOAD_COMPLETE));
      }
    }
  }
}
