package wmap{
  import flash.display.BitmapData;
  import flash.geom.Point;

//--------------------------------------------------------------------//
// ʐ}@
  public class AEPMap extends Map2D{

// ʐ}@\
    public static const NAME:String="AEP";

    public function AEPMap(theta:Number=0.0,phy:Number=0.0):void{
      super(theta,phy);
    }

//--------------------------------------------------------------------//
// f[^Rs[
// map - Qƌ̃f[^
    public override function copy(map:Map2D):void{
      super.copy(map);
      vx=90.0/radius;
      vy=vx;
    }

//--------------------------------------------------------------------//
// nV̔aݒ肷
    public override function setRadius(radius:int):void{
      super.setRadius(radius);
      vx=90.0/radius;
      vy=vx;
    }

//--------------------------------------------------------------------//
// n}̗̈CfbNXԂ
// base - f[^
// x,y - ʏ̑Έʒu
    public override function getPoint(base:BitmapData,
      	      	      	      	      x:Number,y:Number):Point{
      x=(x-cx)/Number(radius);
      y=(cy-y)/Number(radius);
      var r2:Number=x*x+y*y;
      if(r2>1.0){
      	return null;
      }
      else if(r2==0.0){		// S_
      	var i:int=base.width*3/2+int(base.width*theta/360.0);
      	var j:int=base.height/2-int(base.height*phy/180.0);
      	point.x=i%base.width;
      	point.y=j;
      }
      else{
      	var sphy:Number=Math.sin(TO_RADIAN*phy);
      	var cphy:Number=Math.cos(TO_RADIAN*phy);
      	var r:Number=Math.sqrt(r2);
      	var gy:Number=y/r;
      	var ssd:Number=Math.sin(Math.PI*r);
      	var ccd:Number=Math.cos(Math.PI*r);
      	var ssy:Number=sphy*ccd+cphy*ssd*gy;
      	var ccy:Number=1.0-ssy*ssy;
      	if(ccy<TOLERANCE){
      	  if(ssy>0.0){	// kɓ_
      	    point.x=0;
      	    point.y=0;
      	  }
      	  else{		// ɓ_
      	    point.x=base.width-1;
      	    point.y=base.height-1;
      	  }
      	}
      	else{
      	  var yy:Number=PI_INV*Math.asin(ssy);
      	  var ccx:Number=(cphy*ccd-sphy*ssd*gy)/Math.sqrt(ccy);
      	  var xx:Number=0.0;
      	  if(ccx<-1.0+TOLERANCE)      xx=0.5;
      	  else if(ccx<=1.0-TOLERANCE) xx=0.5*PI_INV*Math.acos(ccx);
      	  if(x<0) xx=-xx;
      	  i=base.width/2+int(base.width*(1.0+xx+theta/360.0));
      	  j=base.height/2-int(base.height*yy);
      	  point.x=i%base.width;
      	  point.y=j;
      	}
      }
      return point;
    }

//--------------------------------------------------------------------//
// n}̈ʒuԂ
// base - f[^
// x,y - f[^ʒu
    public override function getViewPoint(base:BitmapData,
      	      	      	      	      	  x:int,y:int):Point{
      var sphy:Number=Math.sin(TO_RADIAN*phy);
      var cphy:Number=Math.cos(TO_RADIAN*phy);
      var xx:Number=Number(x)/Number(base.width)-0.5-theta/360.0;
      var yy:Number=-Math.PI*(Number(y)/Number(base.height)-0.5);
      xx*=2.0*Math.PI;

      var cxx:Number=Math.cos(xx);
      var cyy:Number=Math.cos(yy);
      var syy:Number=Math.sin(yy);
      var ccd:Number=cphy*cxx*cyy+sphy*syy;
      var ssd:Number=1.0-ccd*ccd;
      if(ssd<TOLERANCE){
      	if(ccd>0.0){	// S_
      	  point.x=cx;
      	  point.y=cy;
      	}
      	else{		// [_
      	  point.x=radius+cx;
      	  point.y=cy;
      	}
      }
      else{
      	var delta:Number=PI_INV*Math.cos(ccd);
      	var ey:Number=(-sphy*cxx*cyy+cphy*syy)/Math.sqrt(ssd);
      	var ex:Number=delta*Math.sqrt(1.0-ey*ey);
      	ey*=delta;
      	if(Math.sin(xx)<0.0) ex=-ex;
      	point.x=int(radius*ex+cx);
      	point.y=int(-radius*ey+cy);
      }
      return point;
    }
  }
}
