package wmap{
  import flash.display.BitmapData;
  import flash.geom.Point;

//--------------------------------------------------------------------//
// Qn}
  public class Map2D{

// ~̋t
    public static const PI_INV:Number=1.0/Math.PI;  

// pxWAɕϊW
    public static const TO_RADIAN:Number=Math.PI/180.0;

// e덷
    public static const TOLERANCE:Number=1.0E-10;

// nV̔a
    public var radius:int;

// `TCY
    protected var width:int;
    protected var height:int;

// `撆SW
    protected var cx:Number;
    protected var cy:Number;

// _px
    public var theta:Number;
    public var phy:Number;

// ]xW
    internal var vx:Number;
    internal var vy:Number;

// |C^
    internal var point:Point;

// theta,phy - ]p
    public function Map2D(theta:Number,phy:Number):void{
      this.theta=theta;
      this.phy=phy;
      radius=0;
      width=0;
      height=0;
      cx=0.0;
      cy=0.0;
      vx=0.0;
      vy=0.0;
      point=new Point();
    }

//--------------------------------------------------------------------//
// f[^Rs[
// map - Qƌ̃f[^
    public function copy(map:Map2D):void{
      radius=map.radius;
      width=map.width;
      height=map.height;
      cx=map.cx;
      cy=map.cy;
      theta=map.theta;
      phy=map.phy;
    }

//--------------------------------------------------------------------//
// `TCYݒ肷
// width,height - ʕA
    public function setSize(width:int,height:int):void{
      this.width=width;
      this.height=height;
      cx=0.5*width;
      cy=0.5*height;
    }

//--------------------------------------------------------------------//
// nV̔aݒ肷
    public function setRadius(radius:int):void{
      this.radius=radius;
    }

//--------------------------------------------------------------------//
// _pxݒ肷
// theta,phy - _px
    public function setLocation(theta:Number,phy:Number):void{
      this.theta=theta;
      this.phy=phy;
    }

//--------------------------------------------------------------------//
// _ʒu]
    public function rotate(dx:Number,dy:Number):void{
      rotateMap(vx*dx,vy*dy);
    }

//--------------------------------------------------------------------//
// _ʒu]
    public function rotateMap(dx:Number,dy:Number):void{
      theta+=dx;
      if(theta>180.0)       theta-=360.0;
      else if(theta<-180.0) theta+=360.0;
      phy=Math.min(Math.max(phy+dy,-90.0),90.0);
    }

//--------------------------------------------------------------------//
// n}̗̈CfbNXԂ
// base - f[^
// x,y - ʏ̑Έʒu
    public function getPoint(base:BitmapData,x:Number,y:Number):Point{
      return point;
    }

//--------------------------------------------------------------------//
// n}̈ʒuԂ
// base - f[^
// x,y - f[^ʒu
    public function getViewPoint(base:BitmapData,x:int,y:int):Point{
      return point;
    }
  }
}
