package{
  import flash.display.Bitmap;
  import flash.display.Graphics;
  import flash.display.Sprite;
  import component.ViewModel;
  import figure.SphericalAngle;

//--------------------------------------------------------------------//
// Qn}\f
  public class WorldViewModel extends ViewModel{

// nV[h\
    public static const GLOBE:int=0;

// ~}@[h\
    public static const ECP:int=1;

// Cf}@[h\
    public static const MOLLWEIDE:int=2;

// ʐ}@[h\
    public static const AEP:int=3;

// eXvCg
    internal var sprite:Sprite;

// Q}bvf[^f
    internal var model:WorldMapModel;

// \摜
    internal var image:Bitmap;

// nVa̍ől
    internal var radiusMax:int;

// nVa̍ŏl
    internal var radiusMin:int;

// \[h
    public var viewMode:int;

//--------------------------------------------------------------------//
// sprite - eXvCg
// model - Q}bvf[^f
// graphics - `OtBbNX
// x,y,width,height - \ʒuAA
    public function WorldViewModel(sprite:Sprite,model:WorldMapModel,
      	      	      	      	   graphics:Graphics,x:int,y:int,
      	      	      	      	   width:int,height:int){
      super(graphics,x,y,width,height);
      this.sprite=sprite;
      this.model=model;
      image=new Bitmap();
      image.bitmapData=model.image;
      viewMode=GLOBE;
      initRadius(int(0.4*Math.min(width,height)));
      sprite.addChild(image);
    }

//--------------------------------------------------------------------//
// nV̏aݒ肷
// radius - nV̏a
    public function initRadius(radius:int):void{
      radiusMax=3*radius;
      radiusMin=radius;
      model.map.setRadius(radius);
    }

//--------------------------------------------------------------------//
// gEk
// coef - ågEkW
    public function zoom(coef:Number):void{
      if((viewMode==GLOBE) || (viewMode==AEP)){
      	var r:int=int(coef*model.map.radius);
      	r=Math.max(Math.min(r,radiusMax),radiusMin);
      	model.map.setRadius(r);
      	draw();
      }
    }

//--------------------------------------------------------------------//
// |C^ʒu𒆐SɈړ
    public function moveCenter():void{
      model.moveCenter();
      draw();
    }

//--------------------------------------------------------------------//
// ̈於\
    public function clearBoard():void{
      model.clearBoard(sprite);
    }

//--------------------------------------------------------------------//
// ̈於\ǉ
// sprite - eXvCg
// x,y - \ʒu
    public function addNameBoard(x:int,y:int):void{
      model.addNameBoard(sprite,x,y);
    }

//--------------------------------------------------------------------//
// `悷
    public function draw():void{
      model.setImage();
    }
  }
}
