package figure{

//--------------------------------------------------------------------//
// Wpx
  public class SphericalAngle{

// 
    public var theta:Number;

// 
    public var phy:Number;

// sin
    internal var stheta:Number;

// cos
    internal var ctheta:Number;

// sin
    internal var sphy:Number;

// cos
    internal var cphy:Number;

    public function SphericalAngle(){
      theta=0.0;
      phy=0.0;
      stheta=0.0;
      ctheta=1.0;
      sphy=0.0;
      cphy=1.0;
    }

//--------------------------------------------------------------------//
// pxݒ肷
// theta - 
// phy - 
    public function set(theta:Number,phy:Number):void{
      var pi:Number=Math.PI;
      while(theta<-pi) theta+=2.0*pi;
      while(theta>pi) theta-=2.0*pi;
      this.theta=theta;
      this.phy=Math.min(Math.max(phy,-0.5*pi),0.5*pi);
      stheta=Math.sin(this.theta);
      ctheta=Math.cos(this.theta);
      sphy=Math.sin(this.phy);
      cphy=Math.cos(this.phy);
    }

//--------------------------------------------------------------------//
// px]
// dtheta Ɖ]p
// dphy Ӊ]p
    public function rotate(dtheta:Number,dphy:Number):void{
      set(theta+dtheta,phy+dphy);
    }

//--------------------------------------------------------------------//
// _]
// p ]_
    public function rotatePoint(p:Point3D):void{
      var temp:Number=p.x*ctheta+p.y*stheta;
      var x:Number=-p.x*stheta+p.y*ctheta;
      var y:Number=temp*sphy+p.z*cphy;
      var z:Number=temp*cphy-p.z*sphy;
      p.set(x,y,z);
    }
  }
}
