package wmap{
  import flash.display.BitmapData;
  import flash.geom.Point;

//--------------------------------------------------------------------//
// ~}@
  public class ECPMap extends Map2D{

// ~}@\
    public static const NAME:String="ECP";

    public function ECPMap(theta:Number=0.0,phy:Number=0.0):void{
      super(theta,phy);
    }

//--------------------------------------------------------------------//
// f[^Rs[
// map - Qƌ̃f[^
    public override function copy(map:Map2D):void{
      super.copy(map);
      vx=360.0/Number(width);
      vy=0.0;
    }

//--------------------------------------------------------------------//
// `TCYݒ肷
// width,height - ʕA
    public override function setSize(width:int,height:int):void{
      super.setSize(width,height);
      vx=360.0/Number(width);
      vy=0.0;
    }

//--------------------------------------------------------------------//
// n}̗̈CfbNXԂ
// base - f[^
// x,y - ʏ̑Έʒu
    public override function getPoint(base:BitmapData,
      	      	      	      	      x:Number,y:Number):Point{
      var i:int=int(base.width*(1.0+x/width+theta/360.0));
      var j:int=int(base.height*y/height);
      point.x=i%base.width;
      point.y=j;
      return point;
    }

//--------------------------------------------------------------------//
// n}̈ʒuԂ
// base - f[^
// x,y - f[^ʒu
    public override function getViewPoint(base:BitmapData,
      	      	      	      	      	  x:int,y:int):Point{
      var dx:Number=1.0-theta/360.0;
      var gx:int=int(width*(Number(x)/Number(base.width)+dx));
      var gy:int=int(height*Number(y)/Number(base.height));
      point.x=gx%width;
      point.y=gy;
      return point;
    }
  }
}
